/*======================================================================*\
||	[ZP] Extra Item : Kamikaze					||
||	by Sh0oT3R							||
||									||
||	Credits :							||
||  	I used some code from zp_extra_gauss				||
||	and 								||
||	zp_zlass_boomer							||
|| 	Version : 							||
||	-v1.0 - - - First Release					||
||	-v2.0 - - - Fixed all bugs, added more effects, added cvars	||
\*======================================================================*/

#include <amxmodx>
#include <amxmisc>
#include <cstrike>
#include <engine>
#include <fun>
#include <fakemeta>
#include <hamsandwich>
#include <zombieplague>	

#define PLUG_VERSION "2.0"
#define PLUG_AUTH "Sh0oT3R"

new const spr_explosion[] = "sprites/zerogxplode.spr"
new const spr_beam_cylinder[] = "sprites/white.spr"
new const spr_shockwave[] = "sprites/shockwave.spr"
new g_itemid, g_maxplayers
new g_Kamikaze[33]
new g_sprExplosion, g_sprBeam, g_Shockwave
new timer[33]
new cvar_enable, cvar_effects, cvar_kill_delay, cvar_radius, cvar_item_cost

public plugin_init()
{
	register_plugin("[ZP] Extra Item: Kamikaze", PLUG_VERSION, PLUG_AUTH)

	cvar_enable = register_cvar("zp_kamikaze_on", "1") // Enable Plugin [1|0]
	cvar_item_cost = register_cvar("zp_kamikaze_cost", "15") // Cost for Kamikaze [amount]
	cvar_effects = register_cvar("zp_kamikaze_effects", "1") // Special Effects [1|0]
	cvar_kill_delay = register_cvar("zp_kamikaze_delay", "3.0") // Time after buying the item you'll die [float]
	cvar_radius = register_cvar("zp_kamikaze_xplode_radius", "1000.0") // Explode Radius [float]
	
	g_itemid = zp_register_extra_item("Kamikaze", get_pcvar_num(cvar_item_cost), ZP_TEAM_HUMAN)
	g_maxplayers = get_maxplayers() 
}

public plugin_precache()
{	
	g_sprExplosion = precache_model(spr_explosion)
	g_sprBeam = precache_model(spr_beam_cylinder)
	g_Shockwave = precache_model(spr_shockwave)
}

public client_putinserver(id)
{
	g_Kamikaze[id] = false
}

public client_disconnect(id)
{
	g_Kamikaze[id] = false
}

public zp_extra_item_selected(id, item)
{
	if(!get_pcvar_num(cvar_enable) || !zp_has_round_started())
	{
		zp_set_user_ammo_packs(id, zp_get_user_ammo_packs(id)+get_pcvar_num(cvar_item_cost))
		if(!zp_has_round_started())
		client_print(id, print_center, "[Kamikaze] Round hasn't started", id)
		
		return PLUGIN_HANDLED
	}
	else
	{
		if (item == g_itemid)
		{
		set_task(get_pcvar_float(cvar_kill_delay), "KillMe", id)
		set_user_rendering(id, kRenderFxGlowShell, 255, 255, 255, kRenderNormal, 16)
		set_user_godmode(id, 1)
		g_Kamikaze[id] = true
		timer[id] = get_pcvar_num(cvar_kill_delay)
		TimeData(id+300)
		}
	}
	return PLUGIN_HANDLED
}
public TimeData(id)
{
	id -= 300
	if (timer[id] >= 1) {
		client_print(id, print_center, "[Kamikaze] You will be exploded by %d seconds", timer[id])
		RingEnt(id)
		timer[id]--
		set_task(1.0, "TimeData", id+300)
	}
}
public zp_user_infected_post(id)
{
	g_Kamikaze[id] = false
}
public KillMe(id)
{
	
	new data[3], Float:fVec[3]
	new Radius = get_pcvar_num(cvar_radius)
	pev(id, pev_origin, fVec)
	data[0] = floatround(fVec[0])
	data[1] = floatround(fVec[1])
	data[2] = floatround(fVec[2])
	//data[3] = id
	
	
		
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
	write_byte(3)
	write_coord(data[0])
	write_coord(data[1])
	write_coord(data[2])
	write_short(g_sprExplosion);
	write_byte(floatround(float(Radius)));
	//write_byte(floatround(Radius));
	write_byte(15)
	write_byte(0)
	message_end()
	
	if(get_pcvar_num(cvar_effects))
	{
	BloodStream(data, 5)
	BeamCylinder(data)
	}
	
	user_kill(id)
	
	for (new i = 1; i <= g_maxplayers; i++)
	{	
		new PlayerPos[3], name[32], Distance
		get_user_origin(i, PlayerPos)
		get_user_name(id, name, 32)
		
		Distance = get_distance(PlayerPos, data)
		if (Distance <= Radius) 
		{
			if(zp_get_user_zombie(i) && !zp_get_user_survivor(i) && !zp_get_user_nemesis(i))
			{
				message_begin(MSG_ONE, get_user_msgid("ScreenShake"), {0,0,0}, i)  // Shake Screen
				write_short(1<<14)
				write_short(1<<14)
				write_short(1<<14)
				message_end()

				ExecuteHamB(Ham_Killed, i, id, 2);
				client_print(i, print_chat, "[Kamikaze] You have been exploded by %s", name)
			}
		}				
	}
	return PLUGIN_HANDLED
}
public RingEnt(id)
{
new data[3], Float:fVec[3]
pev(id, pev_origin, fVec)
data[0] = floatround(fVec[0])
data[1] = floatround(fVec[1])
data[2] = floatround(fVec[2])

Ring(data)

}
Ring(data[3])
{
message_begin(MSG_BROADCAST, SVC_TEMPENTITY, data) 
write_byte(TE_BEAMCYLINDER)
write_coord(data[0])
write_coord(data[1])
write_coord(data[2])
write_coord(data[0])
write_coord(data[1])
write_coord(data[2]+200)
write_short(g_Shockwave)
write_byte(0)
write_byte(1)
write_byte(6)
write_byte(8)
write_byte(1)
write_byte(0)
write_byte(0)
write_byte(255)
write_byte(128)
write_byte(5)
message_end()
}
BloodStream(data[3], count)
{
	for(new i = 1; i <= count; i++)
	{
		message_begin(MSG_PVS, SVC_TEMPENTITY, data) 
		write_byte(TE_BLOODSTREAM)
		write_coord(data[0])
		write_coord(data[1])
		write_coord(data[2]+40)
		write_coord(random_num(-30,30)) // x
		write_coord(random_num(-30,30)) // y
		write_coord(random_num(80,300)) // z
		write_byte(70) // color
		write_byte(random_num(100,200)) // speed
		message_end()
	}
}
BeamCylinder(data[3])
{
message_begin(MSG_BROADCAST, SVC_TEMPENTITY, data) 
write_byte(TE_BEAMCYLINDER)
write_coord(data[0])
write_coord(data[1])
write_coord(data[2])
write_coord(data[0])
write_coord(data[1])
write_coord(data[2]+200)
write_short(g_sprBeam)
write_byte(0)
write_byte(1)
write_byte(6)
write_byte(8)
write_byte(1)
write_byte(255)
write_byte(255)
write_byte(192)
write_byte(128)
write_byte(5)
message_end()
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1034\\ f0\\ fs16 \n\\ par }
*/
